//Oscillator frequency : 8Mhz

#define LEFT 1
#define RIGHT 0

#define ON 1
#define OFF 0

bit direction;
bit start;
unsigned char TMR0_value;
unsigned char output

void interrupt()
{
  if(T0IF_bit)             //if TMR0 interrupt
  {
    T0IF_bit = 0;         //flag reset
  
    if(start == OFF))
        output = 0;
       
	else if (!output)
		output = 1;
	   
    else
    {
        if(direction == LEFT)
		{ 
			if(output.B3)
				output = 1;
			else
				output = output << 1;
		}
		
		if(direction == RIGHT)
		{ 
			if(output.B0)
				output = 0b00001000;
			else
				output = output >> 1;
		}
        
    }

        
    TMR0 = TMR0_value;   //TMR0_value = 1 -> 30Hz
                          //TMR0_value = 255 -> 7812Hz
                          //by incrementing it each time in this loop you 
                          //can do a soft start (useful for a motor stepper)
	PORTA = output
	}
}

void main() {
  OPTION_REG = 0xFF;       // default value

  //ports setup
  TRISA = 0b11110000;      // 1 -> input
  TRISB = 0xFF;            // 0 -> output

  //timer setup
  T0CS_bit = 0;            //Fosc/4
  PSA_bit = 0;             //8bits prescalar

  PS0_bit = 1;
  PS1_bit = 1;
  PS2_bit = 1;             //256 prescalar
//  timer freq is now 7812Hz
  T0IF_bit = 0;             //flag reset
  T0IE_bit = 1;             //interrupt enable
  
//output initialisation
  output = 1;
  PORTA = output

  PEIE_bit = 1;
  GIE_bit = 1;             //now interrupts are enables

  while(1)
  {
     direction = LEFT;
     start = ON;
  }
}